library indicator;

import 'dart:core';
import 'api.dart';
import 'function.dart';
import 'variables.dart';
import 'dart:convert';
import 'creation.dart';
import 'listener.dart';
import 'package:geiger_api/geiger_api.dart';

Future runIndicator(var indicatorID) async {
  final localMaster =
  (await getGeigerApi('', GeigerApi.masterId, Declaration.doShareData))
  !;
  Storage.controller = localMaster.getStorage();

  Storage.geigerIndicatorUUID = indicatorID;

  await createLocal();
  await init();

  await initPlugin();
  await setValueListener();
  await checkExistNodes();

  await getRecommendation();
  await getRisk();

  if(Storage.getValuePath.isNotEmpty){

  print(Storage.getValuePath.length);

  await getMetrics(Types.users, Storage.userUUID);
  await updateScoreNode(Types.users, Types.geigerScoreUser);
  await updateRecommendationNode(Types.users);

  await getMetrics(Types.devices, Storage.deviceUUID);
  await updateScoreNode(Types.devices, Types.geigerScoreDevice);
  await updateRecommendationNode(Types.devices);

  await getDevices();
  await getEmployees();
  await crtAggregateScore();
  await updateScoreNode(Types.users, Types.geigerScoreAggregate);

  updateScoreMSENode();

  }else{
  print('=======Waiting sensors Values');
  //Listener.sensorsValue.getNumEvents(1,500);

  var bodys = '{"geigerValue": "32.5", "minValue": "0", "cUUID": "5a6487c7-c1c5-4f28-995e-8805e45bf1a3", "maxValue": "100", "valueType": "double", "mUUID": "123e4567-e89b-42d3-a456-556642440sdk-m01", '
  '"threatsImpact": "80efffaf-98a1-4e0a-8f5e-gr89388352ph,High;80efffaf-98a1-4e0a-8f5e-gr89388354sp,High;80efffaf-98a1-4e0a-8f5e-th89388365it,High;80efffaf-98a1-4e0a-8f5e-gr89388350ma,Medium;80efffaf-98a1-4e0a-8f5e-gr89388356db,Medium"}';
  var a = json.decode(bodys.toString());

  await createUserData(a);

  await Listener.sensorsValue.getNumEvents(1,1000).whenComplete(() async => await updateData(Listener.sensorsValue.events.iterator));

  }
}


Future init() async {
  await createLocal();
  await createThreats();
  await createPlugin();
  await createProfiles();
  await createRecommendations();
  await createEnterprise();
//  await createEnterpriseDevices();
//  await createEnterpriseUsers();
//  await createMetricData();

}

